local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local wipe, insert, remove = table.wipe, table.insert, table.remove
local Padding, BorderSize = Widgets.Padding, Widgets.BorderSize

local Editor = {}
_ARTG.Editor = Editor

local ExpansionIcon_Width = 200
local ExpansionIcon_Height = 40
local RaidIcon_Width = 200
local RaidIcon_Height = 100
local BossIcon_Width = 200
local BossIcon_Height = 100

Editor.NoteInfoEdit = function(self,Name,Description,Expansion,Raid,Boss,CallBack)
    --select expansion
    if not _ARTG.DataFuncs.GetRaidInfo("exp.find",Expansion) then 
        local Window = _ARTG:ComponentWindow(Loc:Translation("SELECT_EXPANSION"))

        local Height = Window.Header:GetHeight() + BorderSize + 2*Padding
        for i,v in ipairs(_ARTG.DataFuncs.GetRaidInfo("exp.list")) do 
            Window["ExpansionSelectBtn_"..i] = Widgets:CreateButton(Window)
            Window["ExpansionSelectBtn_"..i]:Size(ExpansionIcon_Width,ExpansionIcon_Height)
            local ExpansionName = _ARTG.DataFuncs.GetRaidInfo("exp.data.name",i)
            Window["ExpansionSelectBtn_"..i]:SetText(ExpansionName,13,"Highlight")
            local imagePath,LeftCoord,RightCoord,TopCoord,BottomCoord = _ARTG.DataFuncs.GetRaidInfo("exp.data.image",i)
            if imagePath then 
                Window["ExpansionSelectBtn_"..i]:SetIcon("TexturePath",imagePath,"LeftCoord",LeftCoord,"RightCoord",RightCoord,"TopCoord",TopCoord,"BottomCoord",BottomCoord)
            end
            if i%2 == 1 then 
                if i == getn(_ARTG.DataFuncs.GetRaidInfo("exp.list")) then 
                    Window["ExpansionSelectBtn_"..i]:SetPoint("TOP",0,-Height)
                    Height = Height + Padding + ExpansionIcon_Height
                else 
                    Window["ExpansionSelectBtn_"..i]:SetPoint("TOPLEFT",BorderSize + Padding,-Height)
                end 
            else 
                Window["ExpansionSelectBtn_"..i]:SetPoint("TOPRIGHT",-BorderSize - Padding,-Height)                
                Height = Height + Padding + ExpansionIcon_Height
            end
            Window["ExpansionSelectBtn_"..i].OnClick = function()
                _ARTG:ComponentWindow()
                Editor:NoteInfoEdit(Name,Description,i,Raid,Boss,CallBack)
            end 
        end 
        Height = Height + BorderSize

        Window:Size(2*ExpansionIcon_Width + 3*Padding + 2*BorderSize,Height)
        return nil 
    end 
    --select raid 
    if not _ARTG.DataFuncs.GetRaidInfo("raid.find",Raid,Expansion) then 
        local Window = _ARTG:ComponentWindow(Loc:Translation("SELECT_RAID"))

        local Height = Window.Header:GetHeight() + BorderSize + 2*Padding

        Window["ExpansionSelectBtn_Return"] = Widgets:CreateButton(Window)
        Window["ExpansionSelectBtn_Return"]:Size(BossIcon_Width,20)
        Window["ExpansionSelectBtn_Return"]:SetText("< "..Loc:Translation("RETURN"),nil,"Highlight",nil,nil,"LEFT")
        Window["ExpansionSelectBtn_Return"]:SetPoint("TOPLEFT",BorderSize + Padding,-Height)
        Window["ExpansionSelectBtn_Return"]:SetPoint("TOPRIGHT",-BorderSize - Padding,-Height)
        Window["ExpansionSelectBtn_Return"].OnClick = function()
            _ARTG:ComponentWindow()
            Editor:NoteInfoEdit(Name,Description,nil,nil,nil,CallBack)
        end 

        Height = Height + 20 + Padding


        for i,v in ipairs(_ARTG.DataFuncs.GetRaidInfo("raid.list",Expansion)) do 
            local RaidName, Icon = _ARTG.DataFuncs.GetRaidInfo("raid.data",v,Expansion)

            Window["ExpansionSelectBtn_"..i] = Widgets:CreateButton(Window)
            Window["ExpansionSelectBtn_"..i]:Size(RaidIcon_Width,RaidIcon_Height)
            Window["ExpansionSelectBtn_"..i]:SetText(RaidName,18,"Highlight")
            if Icon then 
                Window["ExpansionSelectBtn_"..i]:SetIcon("TexturePath",Icon,"LeftCoord",0.05,"RightCoord",0.65,"TopCoord",0.1,"BottomCoord",0.7)
            end
            if i%2 == 1 then 
                if i == getn(_ARTG.DataFuncs.GetRaidInfo("raid.list",Expansion)) then 
                    Window["ExpansionSelectBtn_"..i]:SetPoint("TOP",0,-Height)            
                    Height = Height + Padding + RaidIcon_Height
                else 
                    Window["ExpansionSelectBtn_"..i]:SetPoint("TOPLEFT",BorderSize + Padding,-Height)
                end 
            else 
                Window["ExpansionSelectBtn_"..i]:SetPoint("TOPRIGHT",-BorderSize - Padding,-Height)                
                Height = Height + Padding + RaidIcon_Height
            end
            Window["ExpansionSelectBtn_"..i].OnClick = function()
                _ARTG:ComponentWindow()
                Editor:NoteInfoEdit(Name,Description,Expansion,v,Boss,CallBack)
            end 
        end 
        Height = Height + BorderSize

        Window:Size(2*RaidIcon_Width + 3* Padding + 2*BorderSize,Height)
        return nil
    end 
    --select boss
    if not _ARTG.DataFuncs.GetRaidInfo("boss.find",Boss,Raid,Expansion) then 
        local Window = _ARTG:ComponentWindow(Loc:Translation("SELECT_BOSS"))

        local Height = Window.Header:GetHeight() + BorderSize + 2*Padding
        
        Window["ExpansionSelectBtn_Return"] = Widgets:CreateButton(Window)
        Window["ExpansionSelectBtn_Return"]:Size(BossIcon_Width,20)
        Window["ExpansionSelectBtn_Return"]:SetText("< "..Loc:Translation("RETURN"),nil,"Highlight",nil,nil,"LEFT")
        Window["ExpansionSelectBtn_Return"]:SetPoint("TOPLEFT",BorderSize + Padding,-Height)
        Window["ExpansionSelectBtn_Return"]:SetPoint("TOPRIGHT",-BorderSize - Padding,-Height)
        Window["ExpansionSelectBtn_Return"].OnClick = function()
            _ARTG:ComponentWindow()
            Editor:NoteInfoEdit(Name,Description,Expansion,nil,nil,CallBack)
        end 

        Height = Height + 20 + Padding

        for i,v in ipairs(_ARTG.DataFuncs.GetRaidInfo("boss.list",Raid,Expansion)) do 
            local BossName, Icon  = _ARTG.DataFuncs.GetRaidInfo("boss.data",v,Raid,Expansion)

            Window["ExpansionSelectBtn_"..i] = Widgets:CreateButton(Window)
            Window["ExpansionSelectBtn_"..i]:Size(BossIcon_Width,BossIcon_Height)
            Window["ExpansionSelectBtn_"..i]:SetText(BossName,18,"Highlight")
            if Icon then 
                Window["ExpansionSelectBtn_"..i]:SetIcon("TexturePath",Icon,"LeftCoord",0.1,"RightCoord",1,"TopCoord",0.05,"BottomCoord",0.95)--,0.05,0.65,0,0.7)
            end
            if i%2 == 1 then 
                if i == getn(_ARTG.DataFuncs.GetRaidInfo("boss.list",Raid,Expansion)) then 
                    Window["ExpansionSelectBtn_"..i]:SetPoint("TOP",0,-Height)            
                    Height = Height + Padding + BossIcon_Height
                else 
                    Window["ExpansionSelectBtn_"..i]:SetPoint("TOPLEFT",BorderSize + Padding,-Height)
                end 
            else 
                Window["ExpansionSelectBtn_"..i]:SetPoint("TOPRIGHT",-BorderSize - Padding,-Height)                
                Height = Height + Padding + BossIcon_Height
            end
            Window["ExpansionSelectBtn_"..i].OnClick = function()
                _ARTG:ComponentWindow()
                Editor:NoteInfoEdit(Name,Description,Expansion,Raid,v,CallBack)
            end 
        end 

        Height = Height + BorderSize

        Window:Size(2*BossIcon_Width + 3* Padding + 2*BorderSize,Height)
        return nil 
    end 
    --summary
    local Window = _ARTG:ComponentWindow(Loc:Translation("NOTE_INFORMATION"))
    local Height = Window.Header:GetHeight() + BorderSize + 2*Padding

    local ExpansionName = _ARTG.DataFuncs.GetRaidInfo("exp.data.name",Expansion)
    Window.ExpansionBtn = Widgets:CreateButton(Window)
    Window.ExpansionBtn:Size(300 - 2*BorderSize - 2*Padding,20)
    Window.ExpansionBtn:SetText(ExpansionName,nil,"Highlight")
    Window.ExpansionBtn:SetPoint("TOPLEFT", BorderSize + Padding , -Height)
    Window.ExpansionBtn.OnClick = function()
        _ARTG:ComponentWindow()
        Editor:NoteInfoEdit(Name,Description,nil,Raid,Boss,CallBack)
    end 
    Height = Height + Padding + 20

    local RaidName = _ARTG.DataFuncs.GetRaidInfo("raid.data.name",Raid,Expansion)
    Window.RaidBtn = Widgets:CreateButton(Window)
    Window.RaidBtn:Size(300 - 2*BorderSize - 2*Padding,20)
    Window.RaidBtn:SetText(RaidName,nil,"Highlight")
    Window.RaidBtn:SetPoint("TOPLEFT", BorderSize + Padding , -Height)
    Window.RaidBtn.OnClick = function()
        _ARTG:ComponentWindow()
        Editor:NoteInfoEdit(Name,Description,Expansion,nil,Boss,CallBack)
    end 
    Height = Height + Padding + 20

    local BossName = _ARTG.DataFuncs.GetRaidInfo("boss.data.name",Boss,Raid,Expansion)
    Window.BossBtn = Widgets:CreateButton(Window)
    Window.BossBtn:Size(300 - 2*BorderSize - 2*Padding,20)
    Window.BossBtn:SetText(BossName,nil,"Highlight")
    Window.BossBtn:SetPoint("TOPLEFT", BorderSize + Padding , -Height)
    Window.BossBtn.OnClick = function()
        _ARTG:ComponentWindow()
        Editor:NoteInfoEdit(Name,Description,Expansion,Raid,nil,CallBack)
    end 
    Height = Height + Padding + 20

    Window.NameEdit = Widgets:CreateTextBox(Window)
    Window.NameEdit:SetPoint("TOPLEFT", BorderSize + Padding , -Height)
    Window.NameEdit:Size(300 - 2*BorderSize - 2*Padding,60)
    Window.NameEdit:SetText(Loc:Translation("NOTE_NAME"), 11, "Normal",nil,nil, "LEFT", "TOP")
    Window.NameEdit:SetValue(Loc:Translation("NEW_NOTE"))
    Window.NameEdit.OnValueChanged = function(self,value)
        Name = value
    end
    Height = Height + 60 + Padding

    Window.DescriptionEdit = Widgets:CreateTextBox(Window, 4)
    Window.DescriptionEdit:Size(300 - 2*BorderSize - 2*Padding,93)
    Window.DescriptionEdit:SetText(Loc:Translation("DESCRIPTION"), 11, "Normal", nil, nil, "LEFT", "TOP")
    Window.DescriptionEdit:SetPoint("TOPLEFT", BorderSize + Padding , -Height)
    Window.DescriptionEdit:SetValue(Description)
    Window.DescriptionEdit.OnValueChanged = function(self,value)
        Description = value
    end
    Height = Height + 93 + Padding

    Window.AcceptBtn = Widgets:CreateButton(Window)
    Window.AcceptBtn:Size(150 - BorderSize - 1.5*Padding,20)
    Window.AcceptBtn:SetText(Loc:Translation("ACCEPT"),nil,"Highlight")
    Window.AcceptBtn:SetPoint("TOPLEFT",BorderSize + Padding,-Height)
    Window.AcceptBtn.OnClick = function()
        if CallBack then 
            CallBack(Name,Description,Expansion,Raid,Boss)
        end 
        _ARTG:ComponentWindow()
    end 
    
    Window.CancelBtn = Widgets:CreateButton(Window)
    Window.CancelBtn:Size(150 - BorderSize - 1.5*Padding,20)
    Window.CancelBtn:SetText(Loc:Translation("CANCEL"),nil,"Highlight")
    Window.CancelBtn:SetPoint("TOPRIGHT",-BorderSize - Padding,-Height)  
    Window.CancelBtn.OnClick = function()
        _ARTG:ComponentWindow()
    end 
    Height = Height + BorderSize + Padding + 20

    Window:Size(300,Height)
end

local EntryTypes = {
    {Loc:Translation("TIMED"),
    Loc:Translation("DAMAGE_TAKEN_BY_ABILITY"),
    Loc:Translation("AVERAGE_RAID_HEALTH_SHORT"),
    },
    {"T",
    "A",
    "RH",
    }
}
Editor.NoteEntryConditionEdit = function(self,Entry,Boss,CallBack)
    local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = _ARTG.SV.NoteEntry("Header","Unpack",Entry)
    local Window = _ARTG:ComponentWindow(Loc:Translation("EDIT_NOTE_CONDITION"))

    local Height = Window.Header:GetHeight() + BorderSize + 2*Padding

    --type select
    Window["TypeSelect"] = Widgets:CreateSelectbutton(Window)
    Window["TypeSelect"]:Size(300 - 2*BorderSize - 2*Padding,40)
    Window["TypeSelect"]:SetText(Loc:Translation("ENTRY_TYPE"),nil,nil,nil,nil,"LEFT","TOP")
    Window["TypeSelect"]:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
    Window["TypeSelect"].SelectList = EntryTypes[1]
    Window["TypeSelect"].OnSelect = function(self,value,Index)
        Editor:NoteEntryConditionEdit(_ARTG.SV.NoteEntry("Header","Pack",EntryTypes[2][Index],arg1,arg2,arg3,arg4,arg5,arg6),Boss,CallBack)
    end
    local SelectedType = nil
    for iType,vType in ipairs(EntryTypes[2]) do
        if vType == EntryType then  
            SelectedType = EntryTypes[1][iType]
        end 
    end 
    Window["TypeSelect"]:SetSelected(SelectedType)

    Height = Height + 40 + Padding

    if EntryType then 
        --spell select
        if EntryType == "A" then 
            if _ARTG.BossTemplates[Boss] and _ARTG.BossTemplates[Boss].Abilities then 
                --Template select box
                Window["BossAbilityTemplate_Select"] = Widgets:CreateSelectbutton(Window,"LEFT")
                Window["BossAbilityTemplate_Select"]:Size(300 - 2*BorderSize - 2*Padding,40)
                Window["BossAbilityTemplate_Select"]:SetText(Loc:Translation("SPELL_SELECT"),nil,nil,nil,nil,"LEFT","TOP")
                Window["BossAbilityTemplate_Select"]:SetPoint("TOPLEFT", BorderSize + Padding, -Height)

                local SelectTable = {}
                local SelectedSpell = nil
                for iSpell,vSpell in ipairs(_ARTG.BossTemplates[Boss].Abilities) do 
                    insert(SelectTable,_ARTG.FormatSpellName(vSpell))
                    if arg3 and arg3 == vSpell then 
                        SelectedSpell = iSpell
                    end 
                end 
                insert(SelectTable,"User defined")
                if type(arg3) ~= "nil" and not tContains(_ARTG.BossTemplates[Boss].Abilities,arg3) then 
                    SelectedSpell = getn(SelectTable) 
                end 
                Window["BossAbilityTemplate_Select"].SelectList = SelectTable
                Window["BossAbilityTemplate_Select"]:SetSelected(SelectedSpell)
                Window["BossAbilityTemplate_Select"].OnSelect = function(self,value,Index)
                    if _ARTG.BossTemplates[Boss].Abilities[Index] then 
                        arg3 = _ARTG.BossTemplates[Boss].Abilities[Index]            
                    else 
                        arg3 = -1   
                    end 
                    Editor:NoteEntryConditionEdit(_ARTG.SV.NoteEntry("Header","Pack",EntryType,arg1,arg2,arg3,arg4,arg5,arg6),Boss,CallBack)    
                end
                Height = Height + 40 + Padding    
            end 

            if (not _ARTG.BossTemplates[Boss] or not _ARTG.BossTemplates[Boss].Abilities or 
                    (type(arg3) ~= "nil" and not tContains(_ARTG.BossTemplates[Boss].Abilities,arg3))
                ) 
            then  
                Window["SpellID_LB"] = Widgets:FetchFontString(Window)
                Window["SpellID_LB"]:SetText(Loc:Translation("SPELL_ID"))
                Window["SpellID_LB"]:SetWidth(300 - 2*BorderSize - 2*Padding)
                Window["SpellID_LB"]:SetHeight(20 - Padding)
                Window["SpellID_LB"]:SetJustifyH("LEFT")
                Window["SpellID_LB"]:SetJustifyV("BOTTOM")
                Widgets:SetThemedColor(Window["SpellID_LB"],"Normal")
                Window["SpellID_LB"]:SetPoint("TOPLEFT", BorderSize + Padding, -Height)
                Window["SpellID_TextInput"] = Widgets:CreateBasicTextBox(Window, false, "LEFT")
                Window["SpellID_TextInput"].NumericInputFilter = true
                Window["SpellID_TextInput"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height - 20)
                Window["SpellID_TextInput"]:Size(300 - 2*BorderSize - 2*Padding,20)
                if arg3 and arg3 ~= -1 then 
                    Window["SpellID_TextInput"]:SetValue(arg3)
                end
                Window["SpellID_TextInput"].OnValueChanged = function(self,value)
                    Editor:NoteEntryConditionEdit(_ARTG.SV.NoteEntry("Header","Pack",EntryType,arg1,arg2,value,arg4,arg5,arg6),Boss,CallBack)
                end
                Height = Height + 40 + Padding    
            end 

            if arg3 and arg3 ~= -1 and GetSpellInfo(arg3) then 
                local _,_,Icon = GetSpellInfo(arg3)
                if Icon then 
                    Window["SpellIconFrame"] = Widgets:CreateFrame(Window)
                    Window["SpellIconFrame"]:SetThemedBackdrop()
                    Window["SpellIconFrame"]:Size(20,20)
                    Window["SpellIconFrame"]:SetIcon("TexturePath",Icon,"LeftCoord",0.1,"RightCoord",0.9,"TopCoord",0.1,"BottomCoord",0.9)
                    Window["SpellIconFrame"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height)
                end 
                Window["SpellNameFrame"] = Widgets:CreateFrame(Window)
                Window["SpellNameFrame"]:SetThemedBackdrop()
                if Icon then 
                    Window["SpellNameFrame"]:SetPoint("TOPLEFT", BorderSize + 2*Padding + 20, - Height)
                    Window["SpellNameFrame"]:Size(300 - 2*BorderSize - 2*Padding - 20 - Padding,20)
                else 
                    Window["SpellNameFrame"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height)
                    Window["SpellNameFrame"]:Size(300 - 2*BorderSize - 2*Padding,20)
                end 
                Window["SpellNameFrame"]:SetText(_ARTG.FormatSpellName(arg3),nil,nil,nil,nil,"LEFT")
                Height = Height + 20 + Padding    

                Window["ExactMatch_CheckBox"] = Widgets:CreateCheckbox(Window)
                Window["ExactMatch_CheckBox"]:SetText(Loc:Translation("EXACT_MATCH"))
                Window["ExactMatch_CheckBox"]:Size(0.5*300 - 2*BorderSize - 2*Padding,20)
                Window["ExactMatch_CheckBox"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height)
                Window["ExactMatch_CheckBox"]:SetChecked(arg4)
                Window["ExactMatch_CheckBox"].OnChecked = function(self, value)
                    arg4 = value
                end 
                Height = Height + 20 + Padding

                Window["IgnoreDOT_CheckBox"] = Widgets:CreateCheckbox(Window)
                Window["IgnoreDOT_CheckBox"]:SetText(Loc:Translation("IGNORE_DAMAGE_OVER_TIME"))
                Window["IgnoreDOT_CheckBox"]:Size(300 - 2*BorderSize - 2*Padding,20)
                Window["IgnoreDOT_CheckBox"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height)
                Window["IgnoreDOT_CheckBox"]:SetChecked(arg6)
                Window["IgnoreDOT_CheckBox"].OnChecked = function(self, value)
                    arg6 = value
                end 
                Height = Height + 20 + Padding
            end 
        end 

        --hp select
        if EntryType == "RH" then 
            Window["Health_SliderInput"] = Widgets:CreateSlider(Window)
            Window["Health_SliderInput"]:Size(300 - 2*BorderSize - 2*Padding, 60)
            Window["Health_SliderInput"]:SetText(Loc:Translation("AVERAGE_RAID_HEALTH_IN_%"), 11, 1, 1, 1, "LEFT", "TOP")
            Window["Health_SliderInput"]:SetMinStepMax(0.1, 0.1, 100)
            Window["Health_SliderInput"]:SetValue(arg3)
            Window["Health_SliderInput"]:SetPoint("TOPLEFT",  BorderSize + Padding, - Height)
            Window["Health_SliderInput"].OnValueChanged = function(self, value)
                arg3 = value
            end 
            Height = Height + 60 + Padding

            Window["IgnoreTanks_CheckBox"] = Widgets:CreateCheckbox(Window)
            Window["IgnoreTanks_CheckBox"]:SetText(Loc:Translation("IGNORE_TANKS"))
            Window["IgnoreTanks_CheckBox"]:Size(300 - 2*BorderSize - 2*Padding,20)
            Window["IgnoreTanks_CheckBox"]:SetPoint("TOPLEFT",  BorderSize + Padding, - Height)
            Window["IgnoreTanks_CheckBox"]:SetChecked(arg4)
            Window["IgnoreTanks_CheckBox"].OnChecked = function(self, value)
               arg4 = value
            end 

            Height = Height + 20 + Padding
        end 

        if EntryType ~= "T" then 
            Window["UseTime_CheckBox"] = Widgets:CreateCheckbox(Window)
            Window["UseTime_CheckBox"]:SetText(Loc:Translation("SPECIFY_TIME"))
            Window["UseTime_CheckBox"]:Size(150,20)
            Window["UseTime_CheckBox"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height)
            Window["UseTime_CheckBox"]:SetChecked(arg5)
            Window["UseTime_CheckBox"].OnChecked = function(self, value)
                Editor:NoteEntryConditionEdit(_ARTG.SV.NoteEntry("Header","Pack",EntryType,arg1,arg2,arg3,arg4,value,arg6),Boss,CallBack)
            end 

            Height = Height + 20 + Padding
        end 

        --time select
        if EntryType == "T" or arg5 then 
            Window["Time_LB"] = Widgets:FetchFontString(Window)
            Window["Time_LB"]:SetText(Loc:Translation("TIME"))
            Window["Time_LB"]:SetWidth(300 - 2*BorderSize - 2*Padding)
            Window["Time_LB"]:SetHeight(40 - 2*BorderSize - 2*Padding)
            Window["Time_LB"]:SetJustifyH("LEFT")
            Window["Time_LB"]:SetJustifyV("TOP")
            Widgets:SetThemedColor(Window["Time_LB"],"Normal")
            Window["Time_LB"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height - BorderSize - Padding)
            Window["Time_TextBox"] = Widgets:CreateBasicTextBox(Window, false, "LEFT")
            Window["Time_TextBox"].NumericInputFilter = true
            Window["Time_TextBox"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height - 20)
            Window["Time_TextBox"]:Size(300 - 2*BorderSize - 2*Padding,20)
            Window["Time_TextBox"]:SetValue(arg1)
            Window["Time_TextBox"].OnValueChanged = function(self,value)
                arg1 = value
            end
            Height = Height + 40 + Padding

            Window["ErrorMargin_LB"] = Widgets:FetchFontString(Window)
            Window["ErrorMargin_LB"]:SetText(Loc:Translation("ERROR_MARGIN"))
            Window["ErrorMargin_LB"]:SetWidth(300 - 2*BorderSize - 2*Padding)
            Window["ErrorMargin_LB"]:SetHeight(40 - 2*BorderSize - 2*Padding)
            Window["ErrorMargin_LB"]:SetJustifyH("LEFT")
            Window["ErrorMargin_LB"]:SetJustifyV("TOP")
            Widgets:SetThemedColor(Window["ErrorMargin_LB"],"Normal")
            Window["ErrorMargin_LB"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height - BorderSize - Padding)
            Window["ErrorMargin_TextBox"] = Widgets:CreateBasicTextBox(Window, false, "LEFT")
            Window["ErrorMargin_TextBox"].NumericInputFilter = true
            Window["ErrorMargin_TextBox"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height - 20)
            Window["ErrorMargin_TextBox"]:Size(300 - 2*BorderSize - 2*Padding,20)
            Window["ErrorMargin_TextBox"]:SetValue(arg2)
            Window["ErrorMargin_TextBox"].OnValueChanged = function(self,value)
                arg2 = value
            end
            Height = Height + 40 + Padding
        end 

        if EntryType ~= "A" or GetSpellInfo(arg3) then 
            Window.AcceptBtn = Widgets:CreateButton(Window)
            Window.AcceptBtn:Size(150 - BorderSize - 1.5*Padding,20)
            Window.AcceptBtn:SetText(Loc:Translation("ACCEPT"),nil,"Highlight")
            Window.AcceptBtn:SetPoint("TOPLEFT",BorderSize + Padding,-Height)
            Window.AcceptBtn.OnClick = function()
                if CallBack then 
                    CallBack(_ARTG.SV.NoteEntry("Header","Pack",EntryType,arg1,arg2,arg3,arg4,arg5,arg6))
                end 
                _ARTG:ComponentWindow()
            end 
            
            Window.CancelBtn = Widgets:CreateButton(Window)
            Window.CancelBtn:Size(150 - BorderSize - 1.5*Padding,20)
            Window.CancelBtn:SetText(Loc:Translation("CANCEL"),nil,"Highlight")
            Window.CancelBtn:SetPoint("TOPRIGHT",-BorderSize - Padding,-Height)  
            Window.CancelBtn.OnClick = function()
                _ARTG:ComponentWindow()
            end 
            Height = Height + Padding + 20
        end 
    end 

    Height = Height + BorderSize

    Window:Size(300,Height)
end 

Editor.NoteCooldownEdit = function(self,CDLink,CallBack)
    --local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = _ARTG.SV.NoteEntry("Header","Unpack",Entry)
    local DisplayString,CD,PlayerName = _ARTG.SV.NoteEntry("CD","Display",CDLink)
    local Window = _ARTG:ComponentWindow(Loc:Translation("EDIT_NOTE_CONDITION"))

    local Height = Window.Header:GetHeight() + BorderSize + 2*Padding

    local SelectItemList = {{},{}}
    local SelectedType = nil
    for ClassName,ClassData in pairs(_ARTG.Data.Cooldowns) do 
        for _,PresetSpellID in ipairs(ClassData) do 
            insert(SelectItemList[1],_ARTG.FormatSpellName(PresetSpellID))
            insert(SelectItemList[2],PresetSpellID)
            if PresetSpellID == CD then 
                SelectedType = getn(SelectItemList[1])
            end 
        end 
    end 
    insert(SelectItemList[1],"User defined")
    insert(SelectItemList[2],-1)
    if not SelectedType then 
        SelectedType = getn(SelectItemList[1])
    end 

    --cd select or enter id
    Window["TypeSelect"] = Widgets:CreateSelectbutton(Window)
    Window["TypeSelect"]:Size(250 - 2*BorderSize - 2*Padding,40)
    Window["TypeSelect"]:SetText(Loc:Translation("COOLDOWN"),nil,nil,nil,nil,"LEFT","TOP")
    Window["TypeSelect"]:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
    Window["TypeSelect"].SelectList = SelectItemList[1]
    Window["TypeSelect"].OnSelect = function(self,value,Index)
        CD = SelectItemList[2][Index]
        Editor:NoteCooldownEdit(_ARTG.SV.NoteEntry("CD","Create",CD,PlayerName),CallBack)
    end
    Window["TypeSelect"]:SetSelected(SelectedType)
    Height = Height + 40 + Padding

    if CD and (CD == -1 or not tContains(SelectItemList[2],CD)) then 
        Window["CD_TextBox"] = Widgets:CreateBasicTextBox(Window, false, "LEFT")
        Window["CD_TextBox"].NumericInputFilter = true
        Window["CD_TextBox"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height)
        Window["CD_TextBox"]:Size(250 - 2*BorderSize - 2*Padding,20)
        if CD ~= -1 then 
            Window["CD_TextBox"]:SetValue(CD)
        end
        Window["CD_TextBox"].OnValueChanged = function(self,value)
            CD = value
            Editor:NoteCooldownEdit(_ARTG.SV.NoteEntry("CD","Create",CD,PlayerName),CallBack)
        end
        Height = Height + 20 + Padding
    end 


    --player name
            Window["Name_LB"] = Widgets:FetchFontString(Window)
            Window["Name_LB"]:SetText(Loc:Translation("PLAYER_NAME"))
            Window["Name_LB"]:SetWidth(250 - 2*BorderSize - 2*Padding)
            Window["Name_LB"]:SetHeight(40 - 2*BorderSize - 2*Padding)
            Window["Name_LB"]:SetJustifyH("LEFT")
            Window["Name_LB"]:SetJustifyV("TOP")
            Widgets:SetThemedColor(Window["Name_LB"],"Normal")
            Window["Name_LB"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height - BorderSize - Padding)
            Window["Name_TextBox"] = Widgets:CreateBasicTextBox(Window, false, "LEFT")
            Window["Name_TextBox"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height - 20)
            Window["Name_TextBox"]:Size(250 - 2*BorderSize - 2*Padding,20)
            Window["Name_TextBox"]:SetValue(PlayerName)
            Window["Name_TextBox"].OnValueChanged = function(self,value)
                PlayerName = value
                Editor:NoteCooldownEdit(_ARTG.SV.NoteEntry("CD","Create",CD,PlayerName),CallBack)
            end
            Height = Height + 40 + Padding

    if CD and GetSpellInfo(CD) then 
        Window["SpellNameFrame"] = Widgets:CreateFrame(Window)
        Window["SpellNameFrame"]:SetThemedBackdrop()
        Window["SpellNameFrame"]:SetPoint("TOPLEFT", BorderSize + Padding, - Height)
        Window["SpellNameFrame"]:Size(250 - 2*BorderSize - 2*Padding,20)
        Window["SpellNameFrame"]:SetText(DisplayString,nil,nil,nil,nil,"LEFT")
        Height = Height + 20 + Padding    

        Window.AcceptBtn = Widgets:CreateButton(Window)
        Window.AcceptBtn:Size(250/2 - BorderSize - 1.5*Padding,20)
        Window.AcceptBtn:SetText(Loc:Translation("ACCEPT"),nil,"Highlight")
        Window.AcceptBtn:SetPoint("TOPLEFT",BorderSize + Padding,-Height)
        Window.AcceptBtn.OnClick = function()
            if CallBack then 
                CallBack(_ARTG.SV.NoteEntry("CD","Create",CD,PlayerName))
            end 
            _ARTG:ComponentWindow()
        end 
        
        Window.CancelBtn = Widgets:CreateButton(Window)
        Window.CancelBtn:Size(250/2 - BorderSize - 1.5*Padding,20)
        Window.CancelBtn:SetText(Loc:Translation("CANCEL"),nil,"Highlight")
        Window.CancelBtn:SetPoint("TOPRIGHT",-BorderSize - Padding,-Height)  
        Window.CancelBtn.OnClick = function()
            _ARTG:ComponentWindow()
        end 

        Height = Height + Padding + 20
    end 

    Height = Height + BorderSize

    Window:Size(250,Height)
end 
