local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local _ARTG = _Avyr_Raid_Tools_ADDON_Globals

--local Tooltip = _Avyr_GUI_Widgets_Tooltip;
local CreateFrame, Minimap, atan2, cos, sin, GetCursorPosition, insert, pairs, UIParent = CreateFrame, Minimap, atan2, cos, sin, GetCursorPosition, table.insert, pairs, UIParent;

local MinimapIcon = CreateFrame("Button", nil, Minimap);
MinimapIcon:SetSize(32, 32);
MinimapIcon:SetFrameStrata("MEDIUM");
MinimapIcon:SetPoint("CENTER", -12, -80);
MinimapIcon:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
MinimapIcon:RegisterForDrag("LeftButton");
MinimapIcon.Backdrop = MinimapIcon:CreateTexture(nil, "BACKGROUND");
MinimapIcon.Backdrop:SetAllPoints();
MinimapIcon.Backdrop:SetTexture("Interface\\PETBATTLES\\BattleBar-AbilityBadge-Neutral")
MinimapIcon.Icon = MinimapIcon:CreateTexture(nil, "BORDER");
MinimapIcon.Icon:SetSize(16, 16);
MinimapIcon.Icon:SetPoint("CENTER");
MinimapIcon.Icon:SetTexture(134331)
MinimapIcon.Border = MinimapIcon:CreateTexture(nil, "BORDER",nil,1);
MinimapIcon.Border:SetAllPoints();
MinimapIcon.Border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
MinimapIcon.Border:SetTexCoord(-0.025, 0.625, -0.05, 0.6);
MinimapIcon.Border:SetRotation(-1.57079632679);

MinimapIcon:SetScript("OnEnter", function(self)
    Widgets:SetTooltip(self,Loc:Translation("ART_MINIMAP_ICON_TOOLTIP_STRING"),-8,-8);
end)


MinimapIcon:SetScript("OnLeave", function()
    Widgets:SetTooltip(self)
end)

MinimapIcon:SetScript("OnDragStart", function(self)
    if not self.isLocked then
        self:SetScript("OnUpdate", function(self)
            local MapX, MapY = Minimap:GetCenter();
            local MouseX, MouseY = GetCursorPosition();
            local MapScale = Minimap:GetEffectiveScale();
            MapX = MapX * MapScale;
            MapY = MapY * MapScale;
            local Ang = atan2(MouseY - MapY, MouseX - MapX);
            local PosX = 80 * cos(Ang);
            local PosY = 80 * sin(Ang);
            self:SetPoint("CENTER", PosX, PosY);
        end)
    end
end)

MinimapIcon:SetScript("OnDragStop", function(self)
    self:SetScript("OnUpdate", nil);
    local _, _, _, x, y = self:GetPoint(1);
    _ARTG.SV.SaveVariable("MI_PosX", x);
    _ARTG.SV.SaveVariable("MI_PosY", y);
end)

MinimapIcon:SetScript("OnMouseUp", function(self, button)
    if button == "RightButton" then
        _ARTG.Editor:Call();
    else
        _ARTG.OptionsMenu:QuickCall();
    end 
end)

MinimapIcon.Refresh = function(self)
    if _ARTG.SV.GetVariable("MI_Enable") then
        self:Show();
        local x,y  =  _ARTG.SV.GetVariable("MI_PosX"), _ARTG.SV.GetVariable("MI_PosY")
        if not x then 
            x = -12
        else 

        end 
        if not y then 
            y = -80
        else 

        end 
        self:SetPoint("CENTER",x,y);
        if _ARTG.SV.GetVariable("G_Enable") then
            self.Icon:SetDesaturated(false);
        else
            self.Icon:SetDesaturated(true);
        end
    else
        self:Hide();
    end
end

_ARTG.MinimapIcon = MinimapIcon;
